import java.io.*;
public class FastCounter{
    public static void main(String[]args){
        if(args.length==0){
            usage("FastCounter AstroChip definition creator");
            return;
        }
        if(args.length!=4){
            usage("Error: there must be four arguments");
            return;
        }
        int m=0;
        int n=0;
        int k=0;
        try{
            m=new Integer(args[1]).intValue();
        }
        catch(Exception e1){
            usage("Error: m is not a valid integer: "+args[1]);
            return;
        }
        try{
            n=new Integer(args[2]).intValue();
        }
        catch(Exception e2){
            usage("Error: n is not a valid integer: "+args[2]);
            return;
        }
        try{
            k=new Integer(args[3]).intValue();
        }
        catch(Exception e3){
            usage("Error: k is not a valid integer: "+args[3]);
            return;
        }
        FileOutputStream fos=null;
        PrintStream ps=null;
        try{
            fos=new FileOutputStream(args[0]);
            ps=new PrintStream(fos);
        }
        catch(Exception e4){
            usage("Error creating file: "+args[0]);
            return;
        }
        try{
            ps.println("MODULE CMP{");
            ps.println("IN a;");
            ps.println("IN cmp;");
            ps.println("IN calculated;");
            ps.println("IN result;");
            ps.println("OUT calculatedo;");
            ps.println("OUT resulto;");
            ps.println("PLA pla 4 2;");
            ps.println("0000 00;");
            ps.println("0001 00;");
            ps.println("0010 10;");
            ps.println("0011 11;");
            ps.println("0100 10;");
            ps.println("0101 10;");
            ps.println("0110 10;");
            ps.println("0111 11;");
            ps.println("1000 11;");
            ps.println("1001 11;");
            ps.println("1010 10;");
            ps.println("1011 11;");
            ps.println("1100 00;");
            ps.println("1101 00;");
            ps.println("1110 10;");
            ps.println("1111 11;");
            ps.println("PLA-END;");
            ps.println("CONNECT a pla0;");
            ps.println("CONNECT cmp pla1;");
            ps.println("CONNECT calculated pla2;");
            ps.println("CONNECT result pla3;");
            ps.println("CONNECT pla0 calculatedo;");
            ps.println("CONNECT pla1 resulto;");
            ps.println("}");
            ps.println("MODULE CHECK{");
            for(int i=0;i<m;i++){
                ps.println("IN ain"+(i+1)+";");
            }
            for(int i=0;i<m;i++){
                ps.println("IN cin"+(i+1)+";");
            }
            ps.println("IN equal;");
            ps.println("IN notequal;");
            ps.println("IN lower;");
            ps.println("IN greater;");
            ps.println("IN lowerequal;");
            ps.println("IN greaterequal;");
            ps.println("IN useresult;");
            ps.println("OUT result;");
            ps.println("CONSTANT c 0;");
            ps.println("INV inv1in inv1out;");
            ps.println("INV inv2in inv2out;");
            ps.println("INV inv3in inv3out;");
            ps.println("INV inv4in inv4out;");
            ps.println("INV inv5in inv5out;");
            ps.println("AND and1in1 and1in2 and1out;");
            ps.println("AND and2in1 and2in2 and2out;");
            ps.println("AND and3in1 and3in2 and3out;");
            ps.println("OR or1in1 or1in2 or1out;");
            ps.println("OR or2in1 or2in2 or2out;");
            ps.println("OR bor1in1 bor1in2 bor1out;");
            ps.println("OR bor2in1 bor2in2 bor2out;");
            ps.println("OR bor3in1 bor3in2 bor3out;");
            ps.println("OR bor4in1 bor4in2 bor4out;");
            ps.println("OR bor5in1 bor5in2 bor5out;");
            ps.println("AND band1in1 band1in2 band1out;");
            ps.println("AND band2in1 band2in2 band2out;");
            ps.println("AND band3in1 band3in2 band3out;");
            ps.println("AND band4in1 band4in2 band4out;");
            ps.println("AND band5in1 band5in2 band5out;");
            ps.println("AND band6in1 band6in2 band6out;");
            ps.println("AND cand1in1 cand1in2 cand1out;");
            ps.println("CMP cmp["+m+"];");
            for(int i=0;i<m;i++){
                ps.println("CONNECT ain"+(i+1)+" cmp["+i+"].a;");
            }
            for(int i=0;i<m;i++){
                ps.println("CONNECT cin"+(i+1)+" cmp["+i+"].cmp;");
            }
            ps.println("CONNECT c cmp[0].calculated;");
            ps.println("CONNECT c cmp[0].result;");
            for(int i=0;i<m-1;i++){
                ps.println("CONNECT cmp["+i+"].calculatedo cmp["+(i+1)+"].calculated;");
            }
            for(int i=0;i<m-1;i++){
                ps.println("CONNECT cmp["+i+"].resulto cmp["+(i+1)+"].result;");
            }
//equal
            ps.println("CONNECT cmp["+(m-1)+"].calculatedo inv1in;");
            ps.println("CONNECT cmp["+(m-1)+"].resulto inv2in;");
            ps.println("CONNECT inv1out and1in1;");
            ps.println("CONNECT inv2out and1in2;");
//not equal
            ps.println("CONNECT cmp["+(m-1)+"].calculatedo or1in1;");
            ps.println("CONNECT cmp["+(m-1)+"].resulto or1in2;");
//lower
            ps.println("CONNECT cmp["+(m-1)+"].calculatedo and2in1;");
            ps.println("CONNECT cmp["+(m-1)+"].resulto inv3in;");
            ps.println("CONNECT inv3out and2in2;");
//greater
            ps.println("CONNECT cmp["+(m-1)+"].calculatedo and3in1;");
            ps.println("CONNECT cmp["+(m-1)+"].resulto and3in2;");
//lowerequal
            ps.println("CONNECT cmp["+(m-1)+"].resulto inv4in;");
//greater equal
            ps.println("CONNECT cmp["+(m-1)+"].calculatedo inv5in;");
            ps.println("CONNECT inv5out or2in1;");
            ps.println("CONNECT cmp["+(m-1)+"].resulto or2in2;");
//match of criterium
            ps.println("CONNECT equal band1in1;");
            ps.println("CONNECT and1out band1in2;");
            ps.println("CONNECT band1out bor1in1;");
            ps.println("CONNECT notequal band2in1;");
            ps.println("CONNECT or1out band2in2;");
            ps.println("CONNECT band2out bor1in2;");
            ps.println("CONNECT lower band3in1;");
            ps.println("CONNECT and2out band3in2;");
            ps.println("CONNECT band3out bor2in1;");
            ps.println("CONNECT greater band4in1;");
            ps.println("CONNECT and3out band4in2;");
            ps.println("CONNECT band4out bor2in2;");
            ps.println("CONNECT lowerequal band5in1;");
            ps.println("CONNECT inv4out band5in2;");
            ps.println("CONNECT band5out bor3in1;");
            ps.println("CONNECT greaterequal band6in1;");
            ps.println("CONNECT or2out band6in2;");
            ps.println("CONNECT band6out bor3in2;");
            ps.println("CONNECT bor1out bor4in1;");
            ps.println("CONNECT bor2out bor4in2;");
            ps.println("CONNECT bor4out bor5in1;");
            ps.println("CONNECT bor3out bor5in2;");
//result used?
            ps.println("CONNECT useresult cand1in1;");
            ps.println("CONNECT bor5out cand1in2;");
            ps.println("CONNECT cand1out result;");
            ps.println("}");
            ps.println("MODULE BITADD{");
            ps.println("IN inb;");
            ps.println("IN in1;");
            ps.println("IN in2;");
            ps.println("OUT out;");
            ps.println("OUT outn;");
            ps.println("PLA pla 3 2;");
            ps.println("000 00;");
            ps.println("001 10;");
            ps.println("010 10;");
            ps.println("011 01;");
            ps.println("100 10;");
            ps.println("101 01;");
            ps.println("110 01;");
            ps.println("111 11;");
            ps.println("PLA-END;");
            ps.println("CONNECT inb pla0;");
            ps.println("CONNECT in1 pla1;");
            ps.println("CONNECT in2 pla2;");
            ps.println("CONNECT pla0 out;");
            ps.println("CONNECT pla1 outn;");
            ps.println("}");
            ps.println("MODULE main{");
            int n1=1;
            int m1=n;
            ps.println("CONSTANT equal 1;");
            ps.println("CONSTANT notequal 0;");
            ps.println("CONSTANT lower 0;");
            ps.println("CONSTANT greater 0;");
            ps.println("CONSTANT lowerequal 0;");
            ps.println("CONSTANT greaterequal 0;");
            for(int i=0;i<n;i++){
                ps.println("CONSTANT useresult"+(i+1)+" 1;");
            }
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    int cv=(int)(Math.random()*2);
                    ps.println("CONSTANT c"+(i+1)+"x"+(j+1)+" "+cv+";");
                }
            }
            for(int j=0;j<m;j++){
                int cv=(int)(Math.random()*2);
                ps.println("CONSTANT cmpc"+(j+1)+" "+cv+";");
            }
            ps.println("CHECK check["+n+"];");
            IndexHolder indeh=new IndexHolder();
            int nb=n1;
            int cur=m1;
            int index=0;
            while(cur>1){
                ps.println("ONESTAGE"+nb+"x"+cur+" onestage"+index+";");
                indeh.addstage(nb,cur);
                index=index+1;
                nb=nb+1;
                cur=cur/2+cur%2;
            }
            ps.println("COUNTER counter;");
            for(int i=0;i<k;i++){
                ps.println("BIT in"+(i+1)+" out"+(i+1)+" read"+(i+1)+" set"+(i+1)+" 0;");
            }
            ps.println("BIT overflowin overflowout overflowread overflowset 0;");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            for(int i=0;i<k;i++){
                ps.println("CONNECT d read"+(i+1)+";");
                ps.println("CONNECT d set"+(i+1)+";");
            }
            ps.println("CONNECT d overflowread;");
            ps.println("CONNECT d overflowset;");
            for(int i=0;i<n;i++){
                ps.println("CONNECT equal check["+i+"].equal;");
                ps.println("CONNECT notequal check["+i+"].notequal;");
                ps.println("CONNECT lower check["+i+"].lower;");
                ps.println("CONNECT greater check["+i+"].greater;");
                ps.println("CONNECT lowerequal check["+i+"].lowerequal;");
                ps.println("CONNECT greaterequal check["+i+"].greaterequal;");
                ps.println("CONNECT useresult"+(i+1)+" check["+i+"].useresult;");
                for(int j=0;j<m;j++){
                    ps.println("CONNECT c"+(i+1)+"x"+(j+1)+" check["+i+"].ain"+(j+1)+";");
                }
                for(int j=0;j<m;j++){
                    ps.println("CONNECT cmpc"+(j+1)+" check["+i+"].cin"+(j+1)+";");
                }
            }
            for(int i=0;i<n1;i++){
                for(int j=0;j<m1;j++){
                    int cv=(int)(Math.random()*2);
                    ps.println("CONNECT check["+j+"].result onestage0.in"+(i+1)+"x"+(j+1)+";");
                }
            }
            nb=n1;
            cur=m1;
            index=0;
            while(cur>1){
                index=index+1;
                nb=nb+1;
                cur=cur/2+cur%2;
                for(int i=0;i<nb;i++){
                    for(int j=0;j<cur;j++){
                        if(cur!=1){
                            ps.println("CONNECT onestage"+(index-1)+".out"+(i+1)+"x"+(j+1)+" onestage"+index+".in"+(i+1)+"x"+(j+1)+";");
                        }
                        else{
                            if(i<k){
                                ps.println("CONNECT onestage"+(index-1)+".out"+(i+1)+"x"+(j+1)+" counter.ain"+(i+1)+";");
                            }
                        }
                    }
                }
            }
            for(int i=nb;i<k;i++){
                ps.println("CONNECT c counter.ain"+(i+1)+";");
            }
            ps.println("CONNECT counter.overflowo counter.overflow;");
            for(int i=0;i<k;i++){
                ps.println("CONNECT counter.out"+(i+1)+" counter.bin"+(i+1)+";");
            }
            for(int i=0;i<k;i++){
                ps.println("CONNECT counter.out"+(i+1)+" in"+(i+1)+";");
            }
            ps.println("CONNECT counter.overflowo overflowin;");
            ps.println("}");
            addcounter(ps,k);
            for(int k1=0;k1<indeh.onestagen;k1++){
                onestage(ps,indeh.onestagelen[k1],indeh.onestagecount[k1],indeh);
            }
            for(int k1=0;k1<indeh.oneaddern;k1++){
                oneadder(ps,indeh.oneadderlen[k1]);
            }
        }
        catch(Exception e){
            e.printStackTrace(System.out);
            System.out.println("error creating AstroChip definition");
        }
    }
    public static void onestage(PrintStream ps,int len,int oneaddercount,IndexHolder indeh){
        try{
            ps.println("MODULE ONESTAGE"+len+"x"+oneaddercount+"{");
            for(int i=1;i<=len;i++){
                for(int j=1;j<=oneaddercount;j++){
                    ps.println("IN in"+i+"x"+j+";");
                }
            }
            int oacounthalf=oneaddercount/2;
            int addnr=oneaddercount%2;
            for(int i=1;i<=len+1;i++){
                for(int j=1;j<=oacounthalf+addnr;j++){
                    ps.println("OUT out"+i+"x"+j+";");
                }
            }
            if(addnr==1){
                ps.println("CONSTANT c 0;");
            }
            for(int i=1;i<=oacounthalf;i++){
                ps.println("ONEADDER"+len+" anadder"+i+";");
            }
            indeh.addadder(len);
            for(int i=1;i<=len;i++){
                for(int j=1;j<=oacounthalf;j++){
                    ps.println("CONNECT in"+i+"x"+(2*j-1)+" anadder"+j+".a"+i+";");
                    ps.println("CONNECT in"+i+"x"+(2*j)+" anadder"+j+".b"+i+";");
                }
            }
            for(int i=1;i<=len+1;i++){
                for(int j=1;j<=oacounthalf;j++){
                    ps.println("CONNECT anadder"+j+".out"+i+" out"+i+"x"+j+";");
                }
            }
            if(addnr==1){
                int jb=oneaddercount;
                for(int i=1;i<=len;i++){
                    ps.println("CONNECT in"+i+"x"+jb+" out"+i+"x"+(oacounthalf+addnr)+";");
                }
                ps.println("CONNECT c out"+(len+1)+"x"+(oacounthalf+addnr)+";");
            }
            ps.println("}");
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static void oneadder(PrintStream ps,int len){
        try{
            ps.println("MODULE ONEADDER"+len+"{");
            for(int i=1;i<=len;i++){
                ps.println("IN a"+i+";");
                ps.println("IN b"+i+";");
            }
            for(int i=1;i<=len+1;i++){
                ps.println("OUT out"+i+";");
            }
            ps.println("CONSTANT c 0;");
            for(int i=1;i<=len;i++){
                ps.println("BITADD bitadder"+i+";");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT a"+i+" bitadder"+i+".in1;");
                ps.println("CONNECT b"+i+" bitadder"+i+".in2;");
            }
            ps.println("CONNECT c bitadder1.inb;");
            for(int i=1;i<=len-1;i++){
                ps.println("CONNECT bitadder"+i+".outn bitadder"+(i+1)+".inb;");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT bitadder"+i+".out out"+i+";");
            }
            ps.println("CONNECT bitadder"+len+".outn out"+(len+1)+";");
            ps.println("}");
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static void addcounter(PrintStream ps,int len){
        try{
            ps.println("MODULE COUNTER{");
            ps.println("CYCLE 1;");
            for(int i=1;i<=len;i++){
                ps.println("IN ain"+i+";");
                ps.println("IN bin"+i+";");
            }
            ps.println("IN overflow;");
            for(int i=1;i<=len;i++){
                ps.println("OUT out"+i+";");
            }
            ps.println("OUT overflowo;");
            ps.println("CONSTANT c 0;");
            ps.println("OR orin1 orin2 orout;");
            for(int i=1;i<=len;i++){
                ps.println("BITADD bitadder"+i+";");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT ain"+i+" bitadder"+i+".in1;");
                ps.println("CONNECT bin"+i+" bitadder"+i+".in2;");
            }
            ps.println("CONNECT c bitadder1.inb;");
            for(int i=1;i<=len-1;i++){
                ps.println("CONNECT bitadder"+i+".outn bitadder"+(i+1)+".inb;");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT bitadder"+i+".out out"+i+";");
            }
            ps.println("CONNECT bitadder"+len+".outn orin1;");
            ps.println("CONNECT overflow orin2;");
            ps.println("CONNECT orout overflowo;");
            ps.println("}");
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static void usage(String errormessage){
        System.out.println(errormessage);
        System.out.println("usage: java FastCounter outputfile.txt m n k");
        System.out.println("outputfile.txt will be created with the AstroChip definition text. ");
        System.out.println("m: Integer, number of binary digits of each number");
        System.out.println("n: Integer, number of numbers to be checked in one cycle");
        System.out.println("k: Integer, number of binary digits in the count result");
    }
}
class IndexHolder{
    int[]onestagelen=new int[0];
    int[]onestagecount=new int[0];
    int onestagen=0;
    int[]oneadderlen=new int[0];
    int oneaddern=0;
    public IndexHolder(){
    }
    public void addstage(int a,int b){
        int nb=onestagen+1;
        int[]array1=new int[nb];
        int[]array2=new int[nb];
        for(int i=0;i<nb-1;i++){
            array1[i]=onestagelen[i];
            array2[i]=onestagecount[i];
        }
        array1[nb-1]=a;
        array2[nb-1]=b;
        onestagelen=array1;
        onestagecount=array2;
        onestagen=onestagen+1;
    }
    public void addadder(int a){
        int nb=oneaddern+1;
        int[]array1=new int[nb];
        for(int i=0;i<nb-1;i++){
            array1[i]=oneadderlen[i];
        }
        array1[nb-1]=a;
        oneadderlen=array1;
        oneaddern=oneaddern+1;
    }
}
